<template>
  <div class="popup" :style="{display: hidden ? 'none' : ''}">
    <div class="popup__wrapper">
      <div class="popup__header">
        <h3 class="popup__header-title">{{$user.email === '' ? 'Привяжите Email' : 'Подтверждение email'}}</h3>
        <div class="popup__close close" @click="hide" v-if="hidden || isPos"></div>
      </div>
      <hr class="popup__divider">
      <div class="popup__content">
        <div v-show="$user.email !== ''">
          <div class="popup__warning-mail-not-confirm warning yellow left" v-if="!nowarning">
            <div class="warning__wrapper">
              <div class="warning__icon"></div>
              <h3 class="warning__title">Внимание</h3>
              <p class="warning__text">Ваш адрес электронной почты не подтвержден. Для продолжения работы с личным кабинетом
                необходимо подтвердить или изменить его.
              </p>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="columns twelve padding">
            <label>{{$user.email === '' ? 'Ваш Email' : 'Текущий адрес'}}</label>
            <input type="text"
                   name="email"
                   id="email"
                   v-model="email"
                   @input="error = ''"
                   v-validate="'required|email'"
                   @keyup.enter="changeEmail"
                   :class="{error: vErrors.has('email') || error}"
            >
            <!--<validate-Message v-show="vErrors.has('email') || error">-->
            <!--{{ vErrors.first('email') || error }}-->
            <!--</validate-Message>-->
          </div>
        </div>
        <div class="row">
          <div class="columns twelve padding center">
            <transition name="fade" mode="out-in">
              <button v-if="!timeout"
                      @click="changeEmail"
                      :disabled="$store.getters.getButtonLoading"
                      :class="{button_loading: $store.getters.getButtonLoading}">
                {{buttonText}}
              </button>
              <div v-else class="retry-send">
                <b>Письмо отправлено на {{email}}</b><br>
                Отправить письмо еще раз можно через
                {{timeout}} {{$helpers.plural(timeout, ['секунду', 'секунды', 'секунд'])}}
              </div>
            </transition>
          </div>
        </div>
        <div class="row padding">
          <div class="columns twelve success-message padding">
            Не приходит письмо? Проверьте папку "СПАМ" или воспользуйтесь <a class="link" href="#" @click.prevent.stop="toggleChat">онлайн-чатом</a>, чтобы решить вашу проблему.
          </div>
        </div>
      </div>

    </div>
  </div>
</template>

<script>
  import {errorChangeEmail} from '@/utils/error/change-email'
  import toggleChat from '@/mixins/Chat/ToggleChat'

  export default {
    mixins: [toggleChat],
    mounted() {
      this.email = this.$user.email;



      this.updateProfile();
    },
    data() {
      return {
        email: '',
        error: '',
        timeout: 0,
        interval: null,
      }
    },
    computed: {
      buttonText() {
        if (this.$user.email === '') {
          return 'Привязать Email'
        }
        return this.email === this.$user.email ? 'Отправить письмо' : 'Изменить адрес'
      },
        isPos () {
          return !!(this.$installment.payment.current_limit || this.$installment.payment.current_arrear);
        }
    },
    watch: {
      '$user.emailConfirmed' (val) {
          if (val) {
            this.hide();
            this.$helpers.noscroll(false);
          }
      },
      email () {
        if (this.timeout) {
          this.timeout = 0;
        }

        if (this.interval) {
          clearInterval(this.interval)
        }
      }
    },
    props: {
      hidden: {
        type: Boolean,
        required: false,
        default: false
      },
      nowarning: {
        type: Boolean,
        required: false,
        default: false
      }
    },
    methods: {

      updateProfile() {
          this.$store.dispatch('GET_USER_DATA').then(() => {
            if (!this.$user.emailConfirmed && this.$pdl.status === 6) {
              setTimeout(this.updateProfile, 20000);
            }
          });
      },

      hide() {
        this.$el.style.display = 'none';
        document.querySelector('body').style.overflow = ''
      },
      show() {
        this.$el.style.display = '';
        document.querySelector('body').style.overflow = 'hidden'
        this.email = this.$user.email
      },
      changeEmail() {
        this.$validator.validateAll().then((state) => {
          if (state) {
            this.$store.commit('BUTTON_LOADING', true)
            this.$backend.api.user.email.edit(this.email).then(() => {
              this.$toastr.success('Письмо с ссылкой для активации отправлено на указанный электронный ящик.', 'Успешно')
              this.$user.email = this.email

              this.backCounter();
            }).catch((e) => {
              this.error = errorChangeEmail(e.errors[0].code)
              this.$toastr.error(this.error, 'Ошибка')
            }).finally(() => {
              this.$store.commit('BUTTON_LOADING', false)
            })
          } else {
            this.$toastr.error('Неверно указан e-mail', 'Ошибка')
          }
        })
      },

      backCounter () {
        this.timeout = 60;
        this.interval = setInterval(() => {
          this.timeout -= 1;
          if(this.timeout === 0) {
            clearInterval(this.interval);
          }
        }, 1000)
      }
    }

  }
</script>

<style scoped lang="scss" src="../../../static/css/modals/emailConfirmationRequired.scss">
</style>
